Package uk.ac.starlink.topcat.join

# Class InterMatchSpec

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
javax.swing.JPanel
uk.ac.starlink.topcat.join.MatchSpec
uk.ac.starlink.topcat.join.InterMatchSpec

All Implemented Interfaces:
  `ImageObserver`, `MenuContainer`, `Serializable`, `Accessible`

public class InterMatchSpec extends MatchSpec
MatchSpec for performing matches between multiple tables.

Since:
  20 Mar 2004
Author:
  Mark Taylor (Starlink)
See Also:
  - Serialized Form

## Nested Class Summary

## Nested classes/interfaces inherited from class javax.swing.JPanel

`JPanel.AccessibleJPanel`

## Nested classes/interfaces inherited from class javax.swing.JComponent

`JComponent.AccessibleJComponent`

## Nested classes/interfaces inherited from class java.awt.Container

`Container.AccessibleAWTContainer`

## Nested classes/interfaces inherited from class java.awt.Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

## Field Summary

### Fields inherited from class uk.ac.starlink.topcat.join.MatchSpec

`ENGINE_INFO, MATCHTYPE_INFO`

### Fields inherited from class javax.swing.JComponent

`listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

### Fields inherited from class java.awt.Component

`accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface java.awt.image.ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

## Constructor Summary

Constructors
Constructor
Description
`InterMatchSpec(uk.ac.starlink.table.join.MatchEngine engine, Supplier<uk.ac.starlink.table.RowRunner> runnerFact, int nTable)`
Constructs a new InterMatchSpec.

## Method Summary

Modifier and Type
Method
Description
`void`
`addActionListener(ActionListener l)`
Adds a listener to be notified if the settings of this object change in a way that might change the details of the match being specified.
`void`
`calculate(uk.ac.starlink.table.join.ProgressIndicator indicator)`
Calculates the new matched table.
`void`
`checkArguments()`
Invoked from the event dispatch thread before `MatchSpec.calculate(uk.ac.starlink.table.join.ProgressIndicator)` is called.
`String`
`getDescription()`
`uk.ac.starlink.ttools.task.Setting[]`
`getOutputSettings(uk.ac.starlink.task.Task task)`
Returns stilts command settings specific to this MatchSpec that control match output table generation.
`TupleSelector[]`
`getTupleSelectors()`
Returns the components used to supply input value expressions.
`void`
`matchSuccess(Component parent)`
This method is called from the event dispatch thread if the calculation terminates normally.
`void`
`removeActionListener(ActionListener l)`
Removes a previously added listener.

### Methods inherited from class uk.ac.starlink.topcat.join.MatchSpec

`getDefaultFixActions, getPanel, matchFailure, showSuccessMessage`

### Methods inherited from class javax.swing.JPanel

`getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

### Methods inherited from class javax.swing.JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

### Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

### Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### InterMatchSpec

public InterMatchSpec(uk.ac.starlink.table.join.MatchEngine engine, Supplier<uk.ac.starlink.table.RowRunner> runnerFact, int nTable)
Constructs a new InterMatchSpec.

Parameters:
  `engine` - match algorithm object
  `runnerFact` - supplier for RowRunner
  `nTable` - number of tables on which this InterMatch will operate

## Method Details

### getTupleSelectors

public TupleSelector[] getTupleSelectors()
Description copied from class: `MatchSpec`
Returns the components used to supply input value expressions.

Specified by:
  `getTupleSelectors` in class `MatchSpec`
Returns:
  array of tuple selectors

### checkArguments

public void checkArguments()
Description copied from class: `MatchSpec`
Invoked from the event dispatch thread before `MatchSpec.calculate(uk.ac.starlink.table.join.ProgressIndicator)` is called. A check should be made that it is sensible to call calculate; if not an exception should be thrown.

Specified by:
  `checkArguments` in class `MatchSpec`

### calculate

public void calculate(uk.ac.starlink.table.join.ProgressIndicator indicator) throws IOException, InterruptedException
Calculates the new matched table.

Specified by:
  `calculate` in class `MatchSpec`
Parameters:
  `indicator` - a progress indicator which the calculation should try to update
Throws:
  `IOException` - if there's some trouble
  `InterruptedException` - if the user interrupts the calculation

### matchSuccess

public void matchSuccess(Component parent)
Description copied from class: `MatchSpec`
This method is called from the event dispatch thread if the calculation terminates normally.

Specified by:
  `matchSuccess` in class `MatchSpec`
Parameters:
  `parent` - window controlling the invocation

### getOutputSettings

public uk.ac.starlink.ttools.task.Setting[] getOutputSettings(uk.ac.starlink.task.Task task)
Description copied from class: `MatchSpec`
Returns stilts command settings specific to this MatchSpec that control match output table generation.

Specified by:
  `getOutputSettings` in class `MatchSpec`
Parameters:
  `task` - stilts match task
Returns:
  output settings array

### getDescription

public String getDescription()

### addActionListener

public void addActionListener(ActionListener l)
Description copied from class: `MatchSpec`
Adds a listener to be notified if the settings of this object change in a way that might change the details of the match being specified.

Overrides:
  `addActionListener` in class `MatchSpec`
Parameters:
  `l` - listener to add

### removeActionListener

public void removeActionListener(ActionListener l)
Description copied from class: `MatchSpec`
Removes a previously added listener.

Overrides:
  `removeActionListener` in class `MatchSpec`
Parameters:
  `l` - listener to remove